#pragma once

#include "Value.h"

#include <string>
#include <vector>

namespace Databoard {
	namespace Value {

		class DATABOARD_API ArrayValue : public Value {
		public:
			ArrayValue(Databoard::Type::DataType* dataBoard);
			virtual ~ArrayValue();

			virtual std::string writeOut(int indent = 0);
			virtual bool equals(const Value* other);

			void add(Value* value);
			void insert(Value* value, int index);
			int count();
			void remove(int index, int count);
			void clear();
			Value* get(int index);

			// snapshot of the array
			std::vector<Value*> getAll();

			virtual std::string isValid();

		protected:

			std::vector<Value*> values;

		};
	}
}
