#include "ByteType.h"

#include "Range.h"
#include "Limit.h"

namespace Databoard {
	namespace Type {

		ByteType::ByteType() : NumberType()
		{
			this->range = NULL;
		}

		ByteType::ByteType(std::string unit) : NumberType(unit)
		{
			this->unit = unit;
			this->range = NULL;
		}

		ByteType::ByteType(std::string unit, Range* range) : NumberType(unit, range)
		{
			this->unit = unit;
			this->range = range;
		}

		ByteType::~ByteType()
		{
		}

		char ByteType::minValue()
		{
			if(range == NULL) return SCHAR_MIN;

			Limit* l = range->getLower();

			char value = l->getByte(SCHAR_MIN);

			return value;
		}

		char ByteType::maxValue()
		{
			if(range == NULL) return SCHAR_MAX;

			Limit* l = range->getUpper();

			char value = l->getByte(SCHAR_MAX);

			return value;
		}

		std::string ByteType::writeOut(int indent)
		{
			std::string s;

			s.append("Byte");

			s += NumberType::writeOut(indent + 1);

			return s;
		}
	}
}
