#include "Range.h"

#include "Limit.h"

#include "Constants.h"

namespace Databoard {

	Range::Range()
	{
		lower = new Limit(true);
		upper = new Limit(false);
	}

	Range::~Range()
	{
		if(lower != NULL)
		{
			delete lower;
			lower = NULL;
		}

		if(upper != NULL)
		{
			delete upper;
			upper = NULL;
		}
	}

	Limit* Range::getLower()
	{
		return lower;
	}

	Limit* Range::getUpper()
	{
		return upper;
	}

	void Range::setLower(std::string value)
	{
		lower->setValue(value);
	}

	void Range::setUpper(std::string value)
	{
		upper->setValue(value);
	}

	std::string Range::writeOut()
	{
		std::string s;

		s += lower->writeOut();

		s += " ";
		s += STR_RANGESPLIT;
		s += " ";

		s += upper->writeOut();

		return s;
	}
}
