/*******************************************************************************
 *  Copyright (c) 2010 Association for Decentralized Information Management in
 *  Industry THTH ry.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 *
 *  Contributors:
 *      VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.tests;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.Random;

import org.simantics.databoard.accessor.error.AccessorConstructionException;
import org.simantics.databoard.accessor.error.AccessorException;
import org.simantics.databoard.accessor.file.FileLibrary;
import org.simantics.databoard.accessor.file.FileVariantAccessor;
import org.simantics.databoard.binding.java.IntegerBindingDefault;
import org.simantics.databoard.util.Base64;


public class Jotakin {

	public static void main(String[] args) throws InterruptedException, AccessorConstructionException, AccessorException, IOException {

		System.out.println( 0.5 % 1.0 );
		System.out.println( 1.1 % 1.0 );
		System.out.println( 1.7 % 1.0 );
		System.out.println( 2.5 % 1.0 );
		
		Random r = new Random();
		byte[] data = new byte[512];
		r.nextBytes(data);
		String str = Base64.encodeBytes(data, Base64.DO_BREAK_LINES | Base64.URL_SAFE);
		byte data2[] = Base64.decode(str, Base64.DO_BREAK_LINES | Base64.URL_SAFE);
		System.out.println( Arrays.equals(data, data2) );
		
		
		FileLibrary lib = new FileLibrary();
		
		File f = new File("c:/temp/joo.dbb");
		
		FileVariantAccessor va = lib.createFile(f);
		System.out.println( System.identityHashCode(va) );
		va.setContentValue(IntegerBindingDefault.INSTANCE, 5);
		
		FileVariantAccessor va2 = lib.getFile(f);
		System.out.println( System.identityHashCode(va2) );
		System.out.println( va2.getContentValue(IntegerBindingDefault.INSTANCE) );
		
		va = null;
		va2 = null;
		System.gc();
		Thread.sleep(1000);
		System.gc();
		lib.expunge();
		System.out.println("Closing file library");
		lib.close();
		/*
		
		ScheduledThreadPoolExecutor executor = new ScheduledThreadPoolExecutor(1);		
		executor.schedule(new Runnable() {@Override
		public void run() {
			System.out.println("HO-ho-Ho");
		}}, 1000, TimeUnit.SECONDS);
		
		ReferenceQueue q = new ReferenceQueue();
		
		Object a = new String("a");
		Object b = new String("b");
		Object c = new String("c");
		
		WeakReference ra = new WeakReference(a, q);
		WeakReference rb = new WeakReference(b, q);
		WeakReference rc = new WeakReference(c, q);
		
		a = null;
		
		System.gc();
		Thread.sleep(1000);
		
		Reference r = q.remove();
		System.out.println( System.identityHashCode( ra ) );
		System.out.println( System.identityHashCode( rb ) );
		System.out.println( System.identityHashCode( rc ) );
		System.out.println( System.identityHashCode( r ) );
		System.out.println( ra == r );
		System.out.println( rb == r );
		System.out.println( rc == r );
		System.out.println(r.get());
		r = q.poll();
		System.out.println(r);
		
		b = null;
		c = null;
		
		Thread.sleep(10000L);
*/

	}
	
}
