/*******************************************************************************
 * Copyright (c) 2010- Association for Decentralized Information Management in
 * Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *    VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.tests;

import java.util.ArrayList;

import org.simantics.databoard.Accessors;
import org.simantics.databoard.accessor.java.JavaArray;
import org.simantics.databoard.accessor.java.JavaInteger;
import org.simantics.databoard.accessor.java.JavaVariant;
import org.simantics.databoard.binding.java.ArrayListBinding;
import org.simantics.databoard.binding.mutable.ImmutableVariantBinding;
import org.simantics.databoard.binding.mutable.MutableVariant;
import org.simantics.databoard.binding.mutable.MutableVariantBinding;
import org.simantics.databoard.binding.mutable.Variant;

public class Jotakin5 {

	public static void main(String[] args) throws Exception {
		
		Variant x = Variant.ofInstance(5);
		Variant y = Variant.ofInstance("X");
		
		MutableVariant mv = new MutableVariant( ImmutableVariantBinding.INSTANCE, x );
		JavaVariant va = Accessors.getAccessor( MutableVariantBinding.INSTANCE , mv );
		va = va.getContentAccessor();
		va.setContentValue(ImmutableVariantBinding.INSTANCE, y);
	
		ArrayList<Variant> list = new ArrayList<Variant>();
		list.add(x);
		JavaArray ja = Accessors.getAccessor( new ArrayListBinding(ImmutableVariantBinding.INSTANCE), list );
		va = ja.getAccessor(0);
		va.setContentValue(ImmutableVariantBinding.INSTANCE, y);
		
		MutableVariant m = MutableVariant.ofInstance(9);
		va = Accessors.getAccessor( MutableVariantBinding.INSTANCE, m);
		JavaInteger ji = va.getContentAccessor();
		ji.setValue(2);
	}
	
}

